'use strict';

var React = require('react');
var _ = require('lodash');

var _require = require('yylib-ui'),
    YYClass = _require.YYClass;

var field = YYClass.field;
var PropTypes = YYClass.PropTypes;
var AttachUpload = require('../../attach/AttachUpload');
var ADDR = require('../../BaseHost');

var uiMeta = {
    name: 'AttachUploadWidget',
    fields: [field('serverUrl', ADDR, PropTypes.string, true, '上传地址'), field('fileUrl', ADDR, PropTypes.string, true, ''), field('value', '', PropTypes.string, true, ''), field('allowFileExts', '', PropTypes.string, true, ''), field('billType', '', PropTypes.string, false, ''), field('uploadFailCallback', null, PropTypes.func, true, ''), field('uploadSuccessCallback', null, PropTypes.func, true, ''), field('title', '上传文件', PropTypes.string, true, '上传按钮文本'), field('showUploadList', true, PropTypes.bool, false, '是否显示上传的文件列表'), field('sourceId', null, PropTypes.string, true, '单据id'), field('beforeUpload', null, PropTypes.string, true, ''), field('beforeDel', null, PropTypes.string, true, ''), field('enableUser', true, PropTypes.bool, false, '是否启用获取当前用户'), field('multiple', true, PropTypes.bool, false, '批量上传'), field('sourceType', '', PropTypes.string, false, '自定义类型标识'), field('btnType', '', PropTypes.oneOf(['primary', 'success', 'info', 'warning', 'error', '']), false, '设置按钮类型，可选值为 primary|success|info|warning|error 或者不设'), field('deleteTip', '删除的附件不可恢复！确定要删除？', PropTypes.string, false, '删除附件的提示')]
};
var AttachUploadWidget = YYClass.create({
    uiMeta: uiMeta,
    _getParams: function _getParams() {
        var params = _.assign({}, this.props);
        return params;
    },
    render: function render() {
        var params = this._getParams();
        return React.createElement(AttachUpload, params);
    }
});

module.exports = AttachUploadWidget;