'use strict';

/**
 * 剪切板组件
 */
var React = require('react');
var YYClass = require('../base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;
var CopyToClipboard = require('react-copy-to-clipboard');
//定义META
var uiMeta = {
    name: 'clipboard',
    fields: [
    // field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('text', null, PropTypes.string, false, '被复制的内容'), field('onCopy', undefined, PropTypes.func, false, '内容被复制后的回调'), field('children', null, PropTypes.func, true, '唯一子元素，捕获点击事件')]
};
var YYClipboard = YYClass.create({
    uiMeta: uiMeta,
    render: function render() {
        var cls = this.className();
        return React.createElement(
            'div',
            { className: cls },
            React.createElement(
                CopyToClipboard,
                this.props,
                this.props.children
            )
        );
    }
});
module.exports = YYClipboard;