'use strict';

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var React = require('react');
var YYClass = require('../../base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;

var _require = require('antd'),
    DatePicker = _require.DatePicker;

var MonthPicker = DatePicker.MonthPicker;
require('./style/index.less');
var uiMeta = {
    name: 'monthpicker',
    fields: [
    // field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('value', undefined, PropTypes.oneOf([PropTypes.string, PropTypes.instanceOf(Date)]), false, '日期'), field('defaultValue', '', PropTypes.oneOf([PropTypes.string, PropTypes.instanceOf(Date)]), false, '默认日期'), field('format', "yyyy-MM", PropTypes.string, false, '展示的月份格式'), field('disabledDate', null, PropTypes.func, true, '不可选择的日期'), field('onChange', null, PropTypes.func, true, '时间发生变化的回调'), field('disabled', false, PropTypes.bool, false, '禁用'), field('style', {}, PropTypes.object, false, '自定义输入框样式'), field('popupStyle', {}, PropTypes.object, false, '格外的弹出日历样式'), field('size', 'default', PropTypes.oneOf(['large', 'default', 'small']), false, '输入框大小'), field('locale', {}, PropTypes.object, false, '国际化配置'), field('getCalendarContainer', null, PropTypes.func, true, '定义浮层的容器，默认为 body 上新建 div')]
};

var YYMonthPicker = YYClass.create({
    uiMeta: uiMeta,
    render: function render() {
        var _props = this.props,
            style = _props.style,
            props = _objectWithoutProperties(_props, ['style']);

        return React.createElement(
            'div',
            { className: this.className(), style: style },
            React.createElement(
                MonthPicker,
                props,
                this.props.children
            )
        );
    }
});
module.exports = YYMonthPicker;