'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var React = require('react');
var _ = require('lodash');
var YYClass = require('../../base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;

var _require = require('antd'),
    InputNumber = _require.InputNumber;

var _require2 = require('react-dom'),
    findDOMNode = _require2.findDOMNode;

var classNames = require('classnames');
require('./index.less');
var YYInputCurrency = require('./YYInputCurrency');
var uiMetaFields = require('./uiMetaFields');
//定义META
var uiMeta = {
    name: 'inputnumber',
    fields: uiMetaFields
};

var YYInputNumber = YYClass.create({
    uiMeta: uiMeta,
    getInitialState: function getInitialState() {
        var _props = this.props,
            value = _props.value,
            defaultValue = _props.defaultValue,
            range = _props.range;

        var value = value === null || value === undefined ? range ? [] : defaultValue : value;
        return {
            value: _.cloneDeep(value),
            numValue: _.cloneDeep(value)
        };
    },
    componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
        if ('defaultValue' in nextProps) {
            if (this.props.defaultValue != nextProps.defaultValue) {
                this.setState({ value: _.cloneDeep(nextProps.defaultValue) });
            }
        }
        //value优先级高于defaultValue
        if ('value' in nextProps) {
            if (this.props.value != nextProps.value) {
                this.setState({ value: _.cloneDeep(nextProps.value) });
            }
        }
        if (nextProps.range && _.isEqual(nextProps.defaultValue, nextProps.value)) {
            this.setState({ numValue: _.cloneDeep(nextProps.defaultValue || []) });
        }
        //模式切换的时候重置value
        if ('range' in nextProps) {
            if (this.props.range != nextProps.range) {
                this.setState({
                    value: nextProps.range ? [] : '',
                    numValue: nextProps.range ? [] : null
                });
            }
        }
    },
    _onChange1: function _onChange1(Value) {
        var NumValue = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

        var self = this;
        var _state = this.state,
            value = _state.value,
            numValue = _state.numValue;

        if (this.props.range) {
            value[0] = Value;
            numValue[0] = NumValue;
        } else {
            value = Value;
            numValue = NumValue;
        }
        this.setState({ value: value, numValue: numValue }, function () {
            if (_.isFunction(self.props.onChange)) {
                self.props.onChange(value, numValue);
            }
        });
    },
    _onChange2: function _onChange2(Value) {
        var NumValue = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

        var self = this;
        var _state2 = this.state,
            value = _state2.value,
            numValue = _state2.numValue;

        if (this.props.range) {
            value[1] = Value;
            numValue[1] = NumValue;
            //处理丢失value0
            numValue[0] = value[0];
        } else {
            value = Value;
            numValue = NumValue;
        }
        this.setState({ value: value, numValue: numValue }, function () {
            if (_.isFunction(self.props.onChange)) {
                self.props.onChange(value, numValue);
            }
        });
    },
    componentDidMount: function componentDidMount() {
        if (this.props.stepDisabled === true) {
            this.numHandler(true);
        }
    },
    componentDidUpdate: function componentDidUpdate(prevProps, prevState) {
        if (prevProps.stepDisabled != this.props.stepDisabled) {
            this.numHandler(this.props.stepDisabled);
        }
    },
    numHandler: function numHandler(value) {
        var isVisible = value ? 'hidden' : 'visible';
        var inputNumber1 = this.refs.inputNumber1;
        var inputNumber2 = this.refs.inputNumber2;
        if (inputNumber1) {
            var numHandler = findDOMNode(this.refs.inputNumber1).querySelector('.ant-input-number-handler-wrap');
            numHandler.style.visibility = isVisible;
        }
        if (inputNumber2) {
            var numHandler = findDOMNode(this.refs.inputNumber2).querySelector('.ant-input-number-handler-wrap');
            numHandler.style.visibility = isVisible;
        }
    },
    //渲染前置后置内容
    renderLabledInput: function renderLabledInput(children) {
        var _props2 = this.props,
            addonBefore = _props2.addonBefore,
            addonAfter = _props2.addonAfter;

        var addonBeforeView = addonBefore ? React.createElement(
            'span',
            { className: 'ant-input-group-addon' },
            addonBefore
        ) : null;
        var addonAfterView = addonAfter ? React.createElement(
            'span',
            { className: 'ant-input-group-addon' },
            addonAfter
        ) : null;
        if (addonBefore || addonAfter) {
            return React.createElement(
                'span',
                { className: 'ant-input-wrapper ant-input-group' },
                addonBeforeView,
                children,
                addonAfterView
            );
        } else {
            return children;
        }
    },
    drawSeparator: function drawSeparator() {
        return React.createElement(
            'span',
            { className: this.className() + ' separator' },
            '~'
        );
    },
    drawNumView: function drawNumView(_ref) {
        var _ref$id = _ref.id,
            id = _ref$id === undefined ? 1 : _ref$id,
            _ref$className = _ref.className,
            className = _ref$className === undefined ? null : _ref$className,
            _ref$style = _ref.style,
            style = _ref$style === undefined ? null : _ref$style;

        var _props3 = this.props,
            range = _props3.range,
            props = _objectWithoutProperties(_props3, ['range']);

        var value = this.state.value;

        return React.createElement(InputNumber, _extends({}, props, { value: range ? value['' + (id - 1)] : value, onChange: this['_onChange' + id], className: className, style: style, ref: 'inputNumber' + id }));
    },
    drawCurrView: function drawCurrView(_ref2) {
        var _ref2$id = _ref2.id,
            id = _ref2$id === undefined ? 1 : _ref2$id;

        var _props4 = this.props,
            children = _props4.children,
            range = _props4.range,
            props = _objectWithoutProperties(_props4, ['children', 'range']);

        var value = this.state.value;

        return React.createElement(
            YYInputCurrency,
            _extends({}, props, { value: range ? value['' + (id - 1)] : value, onChange: this['_onChange' + id] }),
            children
        );
    },

    render: function render() {
        var _classNames;

        var _props5 = this.props,
            type = _props5.type,
            direction = _props5.direction,
            range = _props5.range,
            size = _props5.size;

        var rangeClass = classNames((_classNames = {}, _defineProperty(_classNames, 'range-lg', size === 'large'), _defineProperty(_classNames, 'range-sm', size === 'small'), _defineProperty(_classNames, 'range', size === 'default'), _classNames));
        var cls = this.className() + (direction == 'right' ? ' text-right' : ''); //文本右对齐样式
        cls = range ? cls + ' ' + rangeClass : cls;
        switch (type) {
            case 'number':
                {
                    var numView = range ? [this.drawNumView({ id: 1, style: { border: 0 } }), this.drawSeparator(), this.drawNumView({ id: 2, style: { border: 0 } })] : this.drawNumView({});
                    return React.createElement(
                        'div',
                        { className: cls, style: this.props.style },
                        this.renderLabledInput(numView)
                    );
                }
            case 'currency':
                {
                    var currView = range ? [this.drawCurrView({ id: 1 }), this.drawSeparator(), this.drawCurrView({ id: 2 })] : this.drawCurrView({});
                    return currView = range ? React.createElement(
                        'div',
                        { className: 'yyui-inputcurrency' + ' ' + rangeClass },
                        currView
                    ) : currView;
                }
        }
    }
});
module.exports = YYInputNumber;