'use strict';

var React = require('react');
var YYClass = require('../../base/YYClass');
var YYModal = require('../../modal/YYModal');
var field = YYClass.field;
var PropTypes = YYClass.PropTypes;
//定义META
var uiMeta = {
	name: 'refer-link-modal',
	fields: [
	//field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
	field('url', null, PropTypes.string, true, '窗口中iframe内嵌显示的内容地址'), field('visible', false, PropTypes.bool, true, '是否显示窗口'), field('onCancel', null, PropTypes.func, false, '窗口关闭时的回调事件')]
};
//参照中的数据链接点开后查看内容
var LinkDialogView = YYClass.create({
	uiMeta: uiMeta,
	render: function render() {
		var that = this;
		var docHeight = document.documentElement.clientHeight;
		var dlgWidth = document.documentElement.clientWidth * 0.90;
		var dlgHeight = document.documentElement.clientHeight * 0.85;
		return this.props.visible ? React.createElement(
			YYModal,
			{
				width: dlgWidth,
				style: { height: dlgHeight, top: docHeight * 0.05 },
				footer: null,
				closable: true,
				onCancel: that.props.onCancel,
				maskClosable: true,
				className: this.className(),
				visible: this.props.visible },
			React.createElement('iframe', { src: that.props.url, style: { width: dlgWidth - 10, height: dlgHeight - 50, border: 'none' } })
		) : null;
	}
});

module.exports = LinkDialogView;