'use strict';

/**
 * 卡片组件
 */
var React = require('react');
var YYClass = require('../base/YYClass');
var YYDivide = require('../divide/YYDivide');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;
require('./style/count.less');
//定义META
var uiMeta = {
    name: 'count',
    fields: [,
    //field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('columns', null, PropTypes.element, false, '与需要统计的表格列定义一致'), field('dataSource', [], PropTypes.array, false, '需要统计的表格数据，若需统计当前页，则传入当前页的全部数据'), field('title', '合计', PropTypes.string, false, '左侧显示文字')]
};
var YYCount = YYClass.create({
    uiMeta: uiMeta,
    _getData: function _getData(cols, datas, title) {
        var colToSumUp = _.filter(cols, function (col) {
            if (col.isTotal) {
                return col;
            }
        });
        var dom = _.map(colToSumUp, function (col) {
            var curNumber = 0;
            var title = col.title,
                dataIndex = col.dataIndex;

            _.forEach(datas, function (data) {
                for (var key in data) {
                    if (key == dataIndex) {
                        curNumber += data[key];
                    }
                }
            });
            return React.createElement(
                'p',
                { className: dataIndex },
                React.createElement(
                    'span',
                    { className: 'title' },
                    title + '\uFF1A'
                ),
                React.createElement(
                    'span',
                    { className: 'result' },
                    curNumber
                ),
                React.createElement(YYDivide, null)
            );
        });
        return React.createElement(
            'div',
            { className: this.className() },
            React.createElement(
                'p',
                { className: 'sum-title' },
                title + '\uFF1A'
            ),
            dom
        );
    },
    render: function render() {
        var _props = this.props,
            columns = _props.columns,
            dataSource = _props.dataSource,
            title = _props.title;

        var dom = this._getData(columns, dataSource, title);
        return dom;
    }
});

module.exports = YYCount;